------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2007-2009 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
pragma Style_Checks ("NM32766");
with System.Address_To_Access_Conversions;

with Qt4_Debug;

package body Qt4.Rect_Fs is

   procedure Q_Rect_F_Image (Item : Q_Rect_F);
   pragma Export (Ada, Q_Rect_F_Image, "q_rect_f_image");

   function initialize_QRectF
    (Storage : in System.Address)
      return Internals.QRectF_Access;
   pragma Import (C, initialize_QRectF, "__QtAda_inititialize_QRectF");

   function initialize_QRectF_QPointFCR_QSizeFCR
    (Storage : in System.Address;
     Topleft : in Qt4.Point_Fs.Internals.QPointF_Access;
     Size : in Qt4.Size_Fs.Internals.QSizeF_Access)
      return Internals.QRectF_Access;
   pragma Import (C, initialize_QRectF_QPointFCR_QSizeFCR, "__QtAda_inititialize_QRectF_QPointFCR_QSizeFCR");

   function initialize_QRectF_QPointFCR_QPointFCR
    (Storage : in System.Address;
     Topleft : in Qt4.Point_Fs.Internals.QPointF_Access;
     Bottom_Right : in Qt4.Point_Fs.Internals.QPointF_Access)
      return Internals.QRectF_Access;
   pragma Import (C, initialize_QRectF_QPointFCR_QPointFCR, "__QtAda_inititialize_QRectF_QPointFCR_QPointFCR");

   function initialize_QRectF_qreal_qreal_qreal_qreal
    (Storage : in System.Address;
     Left : in Qt4.Q_Real;
     Top : in Qt4.Q_Real;
     Width : in Qt4.Q_Real;
     Height : in Qt4.Q_Real)
      return Internals.QRectF_Access;
   pragma Import (C, initialize_QRectF_qreal_qreal_qreal_qreal, "__QtAda_inititialize_QRectF_qreal_qreal_qreal_qreal");

   function initialize_QRectF_QRectCR
    (Storage : in System.Address;
     Rect : in Qt4.Rects.Internals.QRect_Access)
      return Internals.QRectF_Access;
   pragma Import (C, initialize_QRectF_QRectCR, "__QtAda_inititialize_QRectF_QRectCR");

   function adjust_QRectF
    (Storage : in System.Address;
     From    : in Internals.QRectF_Access)
       return Internals.QRectF_Access;
   pragma Import (C, adjust_QRectF, "__QtAda_adjust_QRectF");

   procedure finalize_QRectF (Object : in Internals.QRectF_Access);
   pragma Import (C, finalize_QRectF, "__QtAda_finalize_QRectF");

   procedure QRectF_adjust_qreal_qreal_qreal_qreal
    (Self : in Internals.QRectF_Access;
     X_1 : in Qt4.Q_Real;
     Y_1 : in Qt4.Q_Real;
     X_2 : in Qt4.Q_Real;
     Y_2 : in Qt4.Q_Real);
   pragma Import (C, QRectF_adjust_qreal_qreal_qreal_qreal, "__QtAda_QRectF_adjust_qreal_qreal_qreal_qreal");

   procedure QRectF_adjusted_qreal_qreal_qreal_qreal
    (Returns : in Internals.QRectF_Access;
     Self : in Internals.QRectF_Access;
     X_1 : in Qt4.Q_Real;
     Y_1 : in Qt4.Q_Real;
     X_2 : in Qt4.Q_Real;
     Y_2 : in Qt4.Q_Real);
   pragma Import (C, QRectF_adjusted_qreal_qreal_qreal_qreal, "__QtAda_QRectF_adjusted_qreal_qreal_qreal_qreal_Q");

   function QRectF_bottom
    (Self : in Internals.QRectF_Access)
       return Qt4.Q_Real;
   pragma Import (C, QRectF_bottom, "__QtAda_QRectF_bottom_Q");

   procedure QRectF_bottomLeft
    (Returns : in Qt4.Point_Fs.Internals.QPointF_Access;
     Self : in Internals.QRectF_Access);
   pragma Import (C, QRectF_bottomLeft, "__QtAda_QRectF_bottomLeft_Q");

   procedure QRectF_bottomRight
    (Returns : in Qt4.Point_Fs.Internals.QPointF_Access;
     Self : in Internals.QRectF_Access);
   pragma Import (C, QRectF_bottomRight, "__QtAda_QRectF_bottomRight_Q");

   procedure QRectF_center
    (Returns : in Qt4.Point_Fs.Internals.QPointF_Access;
     Self : in Internals.QRectF_Access);
   pragma Import (C, QRectF_center, "__QtAda_QRectF_center_Q");

   function QRectF_contains_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QRectF_contains_QPointFCR, "__QtAda_QRectF_contains_QPointFCR_Q");

   function QRectF_contains_qreal_qreal
    (Self : in Internals.QRectF_Access;
     X : in Qt4.Q_Real;
     Y : in Qt4.Q_Real)
       return Interfaces.C.unsigned;
   pragma Import (C, QRectF_contains_qreal_qreal, "__QtAda_QRectF_contains_qreal_qreal_Q");

   function QRectF_contains_QRectFCR
    (Self : in Internals.QRectF_Access;
     R : in Internals.QRectF_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QRectF_contains_QRectFCR, "__QtAda_QRectF_contains_QRectFCR_Q");

   procedure QRectF_getCoords_qrealP_qrealP_qrealP_qrealP
    (Self : in Internals.QRectF_Access;
     X_1 : out Qt4.Q_Real;
     Y_1 : out Qt4.Q_Real;
     X_2 : out Qt4.Q_Real;
     Y_2 : out Qt4.Q_Real);
   pragma Import (C, QRectF_getCoords_qrealP_qrealP_qrealP_qrealP, "__QtAda_QRectF_getCoords_qrealP_qrealP_qrealP_qrealP_Q");

   procedure QRectF_getRect_qrealP_qrealP_qrealP_qrealP
    (Self : in Internals.QRectF_Access;
     X : out Qt4.Q_Real;
     Y : out Qt4.Q_Real;
     W : out Qt4.Q_Real;
     H : out Qt4.Q_Real);
   pragma Import (C, QRectF_getRect_qrealP_qrealP_qrealP_qrealP, "__QtAda_QRectF_getRect_qrealP_qrealP_qrealP_qrealP_Q");

   function QRectF_height
    (Self : in Internals.QRectF_Access)
       return Qt4.Q_Real;
   pragma Import (C, QRectF_height, "__QtAda_QRectF_height_Q");

   procedure QRectF_intersected_QRectFCR
    (Returns : in Internals.QRectF_Access;
     Self : in Internals.QRectF_Access;
     Other : in Internals.QRectF_Access);
   pragma Import (C, QRectF_intersected_QRectFCR, "__QtAda_QRectF_intersected_QRectFCR_Q");

   function QRectF_intersects_QRectFCR
    (Self : in Internals.QRectF_Access;
     R : in Internals.QRectF_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QRectF_intersects_QRectFCR, "__QtAda_QRectF_intersects_QRectFCR_Q");

   function QRectF_isEmpty
    (Self : in Internals.QRectF_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QRectF_isEmpty, "__QtAda_QRectF_isEmpty_Q");

   function QRectF_isNull
    (Self : in Internals.QRectF_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QRectF_isNull, "__QtAda_QRectF_isNull_Q");

   function QRectF_isValid
    (Self : in Internals.QRectF_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, QRectF_isValid, "__QtAda_QRectF_isValid_Q");

   function QRectF_left
    (Self : in Internals.QRectF_Access)
       return Qt4.Q_Real;
   pragma Import (C, QRectF_left, "__QtAda_QRectF_left_Q");

   procedure QRectF_moveBottom_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_moveBottom_qreal, "__QtAda_QRectF_moveBottom_qreal");

   procedure QRectF_moveBottomLeft_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_moveBottomLeft_QPointFCR, "__QtAda_QRectF_moveBottomLeft_QPointFCR");

   procedure QRectF_moveBottomRight_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_moveBottomRight_QPointFCR, "__QtAda_QRectF_moveBottomRight_QPointFCR");

   procedure QRectF_moveCenter_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_moveCenter_QPointFCR, "__QtAda_QRectF_moveCenter_QPointFCR");

   procedure QRectF_moveLeft_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_moveLeft_qreal, "__QtAda_QRectF_moveLeft_qreal");

   procedure QRectF_moveRight_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_moveRight_qreal, "__QtAda_QRectF_moveRight_qreal");

   procedure QRectF_moveTo_qreal_qreal
    (Self : in Internals.QRectF_Access;
     X : in Qt4.Q_Real;
     T : in Qt4.Q_Real);
   pragma Import (C, QRectF_moveTo_qreal_qreal, "__QtAda_QRectF_moveTo_qreal_qreal");

   procedure QRectF_moveTo_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_moveTo_QPointFCR, "__QtAda_QRectF_moveTo_QPointFCR");

   procedure QRectF_moveTop_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_moveTop_qreal, "__QtAda_QRectF_moveTop_qreal");

   procedure QRectF_moveTopLeft_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_moveTopLeft_QPointFCR, "__QtAda_QRectF_moveTopLeft_QPointFCR");

   procedure QRectF_moveTopRight_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_moveTopRight_QPointFCR, "__QtAda_QRectF_moveTopRight_QPointFCR");

   procedure QRectF_normalized
    (Returns : in Internals.QRectF_Access;
     Self : in Internals.QRectF_Access);
   pragma Import (C, QRectF_normalized, "__QtAda_QRectF_normalized_Q");

   function QRectF_right
    (Self : in Internals.QRectF_Access)
       return Qt4.Q_Real;
   pragma Import (C, QRectF_right, "__QtAda_QRectF_right_Q");

   procedure QRectF_setBottom_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_setBottom_qreal, "__QtAda_QRectF_setBottom_qreal");

   procedure QRectF_setBottomLeft_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_setBottomLeft_QPointFCR, "__QtAda_QRectF_setBottomLeft_QPointFCR");

   procedure QRectF_setBottomRight_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_setBottomRight_QPointFCR, "__QtAda_QRectF_setBottomRight_QPointFCR");

   procedure QRectF_setCoords_qreal_qreal_qreal_qreal
    (Self : in Internals.QRectF_Access;
     X_1 : in Qt4.Q_Real;
     Y_1 : in Qt4.Q_Real;
     X_2 : in Qt4.Q_Real;
     Y_2 : in Qt4.Q_Real);
   pragma Import (C, QRectF_setCoords_qreal_qreal_qreal_qreal, "__QtAda_QRectF_setCoords_qreal_qreal_qreal_qreal");

   procedure QRectF_setHeight_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_setHeight_qreal, "__QtAda_QRectF_setHeight_qreal");

   procedure QRectF_setLeft_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_setLeft_qreal, "__QtAda_QRectF_setLeft_qreal");

   procedure QRectF_setRect_qreal_qreal_qreal_qreal
    (Self : in Internals.QRectF_Access;
     X : in Qt4.Q_Real;
     Y : in Qt4.Q_Real;
     W : in Qt4.Q_Real;
     H : in Qt4.Q_Real);
   pragma Import (C, QRectF_setRect_qreal_qreal_qreal_qreal, "__QtAda_QRectF_setRect_qreal_qreal_qreal_qreal");

   procedure QRectF_setRight_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_setRight_qreal, "__QtAda_QRectF_setRight_qreal");

   procedure QRectF_setSize_QSizeFCR
    (Self : in Internals.QRectF_Access;
     S : in Qt4.Size_Fs.Internals.QSizeF_Access);
   pragma Import (C, QRectF_setSize_QSizeFCR, "__QtAda_QRectF_setSize_QSizeFCR");

   procedure QRectF_setTop_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_setTop_qreal, "__QtAda_QRectF_setTop_qreal");

   procedure QRectF_setTopLeft_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_setTopLeft_QPointFCR, "__QtAda_QRectF_setTopLeft_QPointFCR");

   procedure QRectF_setTopRight_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_setTopRight_QPointFCR, "__QtAda_QRectF_setTopRight_QPointFCR");

   procedure QRectF_setWidth_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_setWidth_qreal, "__QtAda_QRectF_setWidth_qreal");

   procedure QRectF_setX_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_setX_qreal, "__QtAda_QRectF_setX_qreal");

   procedure QRectF_setY_qreal
    (Self : in Internals.QRectF_Access;
     Pos : in Qt4.Q_Real);
   pragma Import (C, QRectF_setY_qreal, "__QtAda_QRectF_setY_qreal");

   procedure QRectF_size
    (Returns : in Qt4.Size_Fs.Internals.QSizeF_Access;
     Self : in Internals.QRectF_Access);
   pragma Import (C, QRectF_size, "__QtAda_QRectF_size_Q");

   procedure QRectF_toAlignedRect
    (Returns : in Qt4.Rects.Internals.QRect_Access;
     Self : in Internals.QRectF_Access);
   pragma Import (C, QRectF_toAlignedRect, "__QtAda_QRectF_toAlignedRect_Q");

   procedure QRectF_toRect
    (Returns : in Qt4.Rects.Internals.QRect_Access;
     Self : in Internals.QRectF_Access);
   pragma Import (C, QRectF_toRect, "__QtAda_QRectF_toRect_Q");

   function QRectF_top
    (Self : in Internals.QRectF_Access)
       return Qt4.Q_Real;
   pragma Import (C, QRectF_top, "__QtAda_QRectF_top_Q");

   procedure QRectF_topLeft
    (Returns : in Qt4.Point_Fs.Internals.QPointF_Access;
     Self : in Internals.QRectF_Access);
   pragma Import (C, QRectF_topLeft, "__QtAda_QRectF_topLeft_Q");

   procedure QRectF_topRight
    (Returns : in Qt4.Point_Fs.Internals.QPointF_Access;
     Self : in Internals.QRectF_Access);
   pragma Import (C, QRectF_topRight, "__QtAda_QRectF_topRight_Q");

   procedure QRectF_translate_qreal_qreal
    (Self : in Internals.QRectF_Access;
     Dx : in Qt4.Q_Real;
     Dy : in Qt4.Q_Real);
   pragma Import (C, QRectF_translate_qreal_qreal, "__QtAda_QRectF_translate_qreal_qreal");

   procedure QRectF_translate_QPointFCR
    (Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_translate_QPointFCR, "__QtAda_QRectF_translate_QPointFCR");

   procedure QRectF_translated_qreal_qreal
    (Returns : in Internals.QRectF_Access;
     Self : in Internals.QRectF_Access;
     Dx : in Qt4.Q_Real;
     Dy : in Qt4.Q_Real);
   pragma Import (C, QRectF_translated_qreal_qreal, "__QtAda_QRectF_translated_qreal_qreal_Q");

   procedure QRectF_translated_QPointFCR
    (Returns : in Internals.QRectF_Access;
     Self : in Internals.QRectF_Access;
     P : in Qt4.Point_Fs.Internals.QPointF_Access);
   pragma Import (C, QRectF_translated_QPointFCR, "__QtAda_QRectF_translated_QPointFCR_Q");

   procedure QRectF_united_QRectFCR
    (Returns : in Internals.QRectF_Access;
     Self : in Internals.QRectF_Access;
     Other : in Internals.QRectF_Access);
   pragma Import (C, QRectF_united_QRectFCR, "__QtAda_QRectF_united_QRectFCR_Q");

   function QRectF_width
    (Self : in Internals.QRectF_Access)
       return Qt4.Q_Real;
   pragma Import (C, QRectF_width, "__QtAda_QRectF_width_Q");

   function QRectF_x
    (Self : in Internals.QRectF_Access)
       return Qt4.Q_Real;
   pragma Import (C, QRectF_x, "__QtAda_QRectF_x_Q");

   function QRectF_y
    (Self : in Internals.QRectF_Access)
       return Qt4.Q_Real;
   pragma Import (C, QRectF_y, "__QtAda_QRectF_y_Q");

   function eq_QRectFCR_QRectFCR
    (R_1 : in Internals.QRectF_Access;
     R_2 : in Internals.QRectF_Access)
       return Interfaces.C.unsigned;
   pragma Import (C, eq_QRectFCR_QRectFCR, "__QtAda_eq_QRectFCR_QRectFCR");

   --------------------
   -- Q_Rect_F_Image --
   --------------------

   procedure Q_Rect_F_Image (Item : Q_Rect_F) is
   begin
      Qt4_Debug.Output
       ("(x => "
          & Q_Real_Image (Item.X)
          & ", y => "
          & Q_Real_Image (Item.Y)
          & ", width => "
          & Q_Real_Image (Item.Width)
          & ", height => "
          & Q_Real_Image (Item.Height)
          & ')');
   end Q_Rect_F_Image;

   ------------
   -- Adjust --
   ------------

   overriding
   procedure Adjust (Self : in out Q_Rect_F) is
   begin
      Self.Object := adjust_QRectF (Self.Storage'Address, Self.Object);
      Self.Wrapper := False;
   end Adjust;

   --------------
   -- Finalize --
   --------------

   overriding
   procedure Finalize (Self : in out Q_Rect_F) is
   begin
      if not Self.Wrapper then
         finalize_QRectF (Self.Object);
      end if;
   end Finalize;

   ----------------
   -- Initialize --
   ----------------

   overriding
   procedure Initialize (Self : in out Q_Rect_F) is
      use type Internals.QRectF_Access;

   begin
      if Self.Object = null then
         Self.Object := initialize_QRectF (Self.Storage'Address);
      end if;
   end Initialize;

   ------------
   -- Create --
   ------------

   function Create
     return Q_Rect_F
   is
   begin
      return Self : Q_Rect_F
        := (Ada.Finalization.Controlled with others => <>)
      do
         Self.Object := initialize_QRectF (Self.Storage'Address);
      end return;
   end Create;

   ------------
   -- Create --
   ------------

   function Create
    (Topleft : in Qt4.Point_Fs.Q_Point_F'Class;
     Size : in Qt4.Size_Fs.Q_Size_F'Class)
       return Q_Rect_F
   is
   begin
      return Self : Q_Rect_F
        := (Ada.Finalization.Controlled with others => <>)
      do
         Self.Object := initialize_QRectF_QPointFCR_QSizeFCR (Self.Storage'Address, Qt4.Point_Fs.Internals.QPointF_View (Topleft), Qt4.Size_Fs.Internals.QSizeF_View (Size));
      end return;
   end Create;

   ------------
   -- Create --
   ------------

   function Create
    (Topleft : in Qt4.Point_Fs.Q_Point_F'Class;
     Bottom_Right : in Qt4.Point_Fs.Q_Point_F'Class)
       return Q_Rect_F
   is
   begin
      return Self : Q_Rect_F
        := (Ada.Finalization.Controlled with others => <>)
      do
         Self.Object := initialize_QRectF_QPointFCR_QPointFCR (Self.Storage'Address, Qt4.Point_Fs.Internals.QPointF_View (Topleft), Qt4.Point_Fs.Internals.QPointF_View (Bottom_Right));
      end return;
   end Create;

   ------------
   -- Create --
   ------------

   function Create
    (Left : in Qt4.Q_Real;
     Top : in Qt4.Q_Real;
     Width : in Qt4.Q_Real;
     Height : in Qt4.Q_Real)
       return Q_Rect_F
   is
   begin
      return Self : Q_Rect_F
        := (Ada.Finalization.Controlled with others => <>)
      do
         Self.Object := initialize_QRectF_qreal_qreal_qreal_qreal (Self.Storage'Address, Left, Top, Width, Height);
      end return;
   end Create;

   ------------
   -- Create --
   ------------

   function Create
    (Rect : in Qt4.Rects.Q_Rect'Class)
       return Q_Rect_F
   is
   begin
      return Self : Q_Rect_F
        := (Ada.Finalization.Controlled with others => <>)
      do
         Self.Object := initialize_QRectF_QRectCR (Self.Storage'Address, Qt4.Rects.Internals.QRect_View (Rect));
      end return;
   end Create;

   ------------
   -- Adjust --
   ------------

   procedure Adjust
    (Self : in out Q_Rect_F'Class;
     X_1 : in Qt4.Q_Real;
     Y_1 : in Qt4.Q_Real;
     X_2 : in Qt4.Q_Real;
     Y_2 : in Qt4.Q_Real)
   is
   begin
      QRectF_adjust_qreal_qreal_qreal_qreal (Self.Object, X_1, Y_1, X_2, Y_2);
   end Adjust;

   --------------
   -- Adjusted --
   --------------

   function Adjusted
    (Self : in Q_Rect_F'Class;
     X_1 : in Qt4.Q_Real;
     Y_1 : in Qt4.Q_Real;
     X_2 : in Qt4.Q_Real;
     Y_2 : in Qt4.Q_Real)
       return Q_Rect_F
   is
   begin
      return Returns : Q_Rect_F do
         QRectF_adjusted_qreal_qreal_qreal_qreal (Returns.Object, Self.Object, X_1, Y_1, X_2, Y_2);
      end return;
   end Adjusted;

   ------------
   -- Bottom --
   ------------

   function Bottom
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real
   is
   begin
      return QRectF_bottom (Self.Object);
   end Bottom;

   -----------------
   -- Bottom_Left --
   -----------------

   function Bottom_Left
    (Self : in Q_Rect_F'Class)
       return Qt4.Point_Fs.Q_Point_F
   is
   begin
      return Returns : Qt4.Point_Fs.Q_Point_F do
         QRectF_bottomLeft (Qt4.Point_Fs.Internals.QPointF_View (Returns), Self.Object);
      end return;
   end Bottom_Left;

   ------------------
   -- Bottom_Right --
   ------------------

   function Bottom_Right
    (Self : in Q_Rect_F'Class)
       return Qt4.Point_Fs.Q_Point_F
   is
   begin
      return Returns : Qt4.Point_Fs.Q_Point_F do
         QRectF_bottomRight (Qt4.Point_Fs.Internals.QPointF_View (Returns), Self.Object);
      end return;
   end Bottom_Right;

   ------------
   -- Center --
   ------------

   function Center
    (Self : in Q_Rect_F'Class)
       return Qt4.Point_Fs.Q_Point_F
   is
   begin
      return Returns : Qt4.Point_Fs.Q_Point_F do
         QRectF_center (Qt4.Point_Fs.Internals.QPointF_View (Returns), Self.Object);
      end return;
   end Center;

   --------------
   -- Contains --
   --------------

   function Contains
    (Self : in Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QRectF_contains_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P)), 0);
   end Contains;

   --------------
   -- Contains --
   --------------

   function Contains
    (Self : in Q_Rect_F'Class;
     X : in Qt4.Q_Real;
     Y : in Qt4.Q_Real)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QRectF_contains_qreal_qreal (Self.Object, X, Y), 0);
   end Contains;

   --------------
   -- Contains --
   --------------

   function Contains
    (Self : in Q_Rect_F'Class;
     R : in Q_Rect_F'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QRectF_contains_QRectFCR (Self.Object, R.Object), 0);
   end Contains;

   ----------------
   -- Get_Coords --
   ----------------

   procedure Get_Coords
    (Self : in Q_Rect_F'Class;
     X_1 : out Qt4.Q_Real;
     Y_1 : out Qt4.Q_Real;
     X_2 : out Qt4.Q_Real;
     Y_2 : out Qt4.Q_Real)
   is
   begin
      QRectF_getCoords_qrealP_qrealP_qrealP_qrealP (Self.Object, X_1, Y_1, X_2, Y_2);
   end Get_Coords;

   --------------
   -- Get_Rect --
   --------------

   procedure Get_Rect
    (Self : in Q_Rect_F'Class;
     X : out Qt4.Q_Real;
     Y : out Qt4.Q_Real;
     W : out Qt4.Q_Real;
     H : out Qt4.Q_Real)
   is
   begin
      QRectF_getRect_qrealP_qrealP_qrealP_qrealP (Self.Object, X, Y, W, H);
   end Get_Rect;

   ------------
   -- Height --
   ------------

   function Height
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real
   is
   begin
      return QRectF_height (Self.Object);
   end Height;

   -----------------
   -- Intersected --
   -----------------

   function Intersected
    (Self : in Q_Rect_F'Class;
     Other : in Q_Rect_F'Class)
       return Q_Rect_F
   is
   begin
      return Returns : Q_Rect_F do
         QRectF_intersected_QRectFCR (Returns.Object, Self.Object, Other.Object);
      end return;
   end Intersected;

   ----------------
   -- Intersects --
   ----------------

   function Intersects
    (Self : in Q_Rect_F'Class;
     R : in Q_Rect_F'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QRectF_intersects_QRectFCR (Self.Object, R.Object), 0);
   end Intersects;

   --------------
   -- Is_Empty --
   --------------

   function Is_Empty
    (Self : in Q_Rect_F'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QRectF_isEmpty (Self.Object), 0);
   end Is_Empty;

   -------------
   -- Is_Null --
   -------------

   function Is_Null
    (Self : in Q_Rect_F'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QRectF_isNull (Self.Object), 0);
   end Is_Null;

   --------------
   -- Is_Valid --
   --------------

   function Is_Valid
    (Self : in Q_Rect_F'Class)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (QRectF_isValid (Self.Object), 0);
   end Is_Valid;

   ----------
   -- Left --
   ----------

   function Left
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real
   is
   begin
      return QRectF_left (Self.Object);
   end Left;

   -----------------
   -- Move_Bottom --
   -----------------

   procedure Move_Bottom
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_moveBottom_qreal (Self.Object, Pos);
   end Move_Bottom;

   ----------------------
   -- Move_Bottom_Left --
   ----------------------

   procedure Move_Bottom_Left
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
   is
   begin
      QRectF_moveBottomLeft_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
   end Move_Bottom_Left;

   -----------------------
   -- Move_Bottom_Right --
   -----------------------

   procedure Move_Bottom_Right
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
   is
   begin
      QRectF_moveBottomRight_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
   end Move_Bottom_Right;

   -----------------
   -- Move_Center --
   -----------------

   procedure Move_Center
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
   is
   begin
      QRectF_moveCenter_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
   end Move_Center;

   ---------------
   -- Move_Left --
   ---------------

   procedure Move_Left
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_moveLeft_qreal (Self.Object, Pos);
   end Move_Left;

   ----------------
   -- Move_Right --
   ----------------

   procedure Move_Right
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_moveRight_qreal (Self.Object, Pos);
   end Move_Right;

   -------------
   -- Move_To --
   -------------

   procedure Move_To
    (Self : in out Q_Rect_F'Class;
     X : in Qt4.Q_Real;
     T : in Qt4.Q_Real)
   is
   begin
      QRectF_moveTo_qreal_qreal (Self.Object, X, T);
   end Move_To;

   -------------
   -- Move_To --
   -------------

   procedure Move_To
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
   is
   begin
      QRectF_moveTo_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
   end Move_To;

   --------------
   -- Move_Top --
   --------------

   procedure Move_Top
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_moveTop_qreal (Self.Object, Pos);
   end Move_Top;

   -------------------
   -- Move_Top_Left --
   -------------------

   procedure Move_Top_Left
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
   is
   begin
      QRectF_moveTopLeft_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
   end Move_Top_Left;

   --------------------
   -- Move_Top_Right --
   --------------------

   procedure Move_Top_Right
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
   is
   begin
      QRectF_moveTopRight_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
   end Move_Top_Right;

   ----------------
   -- Normalized --
   ----------------

   function Normalized
    (Self : in Q_Rect_F'Class)
       return Q_Rect_F
   is
   begin
      return Returns : Q_Rect_F do
         QRectF_normalized (Returns.Object, Self.Object);
      end return;
   end Normalized;

   -----------
   -- Right --
   -----------

   function Right
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real
   is
   begin
      return QRectF_right (Self.Object);
   end Right;

   ----------------
   -- Set_Bottom --
   ----------------

   procedure Set_Bottom
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_setBottom_qreal (Self.Object, Pos);
   end Set_Bottom;

   ---------------------
   -- Set_Bottom_Left --
   ---------------------

   procedure Set_Bottom_Left
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
   is
   begin
      QRectF_setBottomLeft_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
   end Set_Bottom_Left;

   ----------------------
   -- Set_Bottom_Right --
   ----------------------

   procedure Set_Bottom_Right
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
   is
   begin
      QRectF_setBottomRight_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
   end Set_Bottom_Right;

   ----------------
   -- Set_Coords --
   ----------------

   procedure Set_Coords
    (Self : in out Q_Rect_F'Class;
     X_1 : in Qt4.Q_Real;
     Y_1 : in Qt4.Q_Real;
     X_2 : in Qt4.Q_Real;
     Y_2 : in Qt4.Q_Real)
   is
   begin
      QRectF_setCoords_qreal_qreal_qreal_qreal (Self.Object, X_1, Y_1, X_2, Y_2);
   end Set_Coords;

   ----------------
   -- Set_Height --
   ----------------

   procedure Set_Height
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_setHeight_qreal (Self.Object, Pos);
   end Set_Height;

   --------------
   -- Set_Left --
   --------------

   procedure Set_Left
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_setLeft_qreal (Self.Object, Pos);
   end Set_Left;

   --------------
   -- Set_Rect --
   --------------

   procedure Set_Rect
    (Self : in out Q_Rect_F'Class;
     X : in Qt4.Q_Real;
     Y : in Qt4.Q_Real;
     W : in Qt4.Q_Real;
     H : in Qt4.Q_Real)
   is
   begin
      QRectF_setRect_qreal_qreal_qreal_qreal (Self.Object, X, Y, W, H);
   end Set_Rect;

   ---------------
   -- Set_Right --
   ---------------

   procedure Set_Right
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_setRight_qreal (Self.Object, Pos);
   end Set_Right;

   --------------
   -- Set_Size --
   --------------

   procedure Set_Size
    (Self : in out Q_Rect_F'Class;
     S : in Qt4.Size_Fs.Q_Size_F'Class)
   is
   begin
      QRectF_setSize_QSizeFCR (Self.Object, Qt4.Size_Fs.Internals.QSizeF_View (S));
   end Set_Size;

   -------------
   -- Set_Top --
   -------------

   procedure Set_Top
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_setTop_qreal (Self.Object, Pos);
   end Set_Top;

   ------------------
   -- Set_Top_Left --
   ------------------

   procedure Set_Top_Left
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
   is
   begin
      QRectF_setTopLeft_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
   end Set_Top_Left;

   -------------------
   -- Set_Top_Right --
   -------------------

   procedure Set_Top_Right
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
   is
   begin
      QRectF_setTopRight_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
   end Set_Top_Right;

   ---------------
   -- Set_Width --
   ---------------

   procedure Set_Width
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_setWidth_qreal (Self.Object, Pos);
   end Set_Width;

   -----------
   -- Set_X --
   -----------

   procedure Set_X
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_setX_qreal (Self.Object, Pos);
   end Set_X;

   -----------
   -- Set_Y --
   -----------

   procedure Set_Y
    (Self : in out Q_Rect_F'Class;
     Pos : in Qt4.Q_Real)
   is
   begin
      QRectF_setY_qreal (Self.Object, Pos);
   end Set_Y;

   ----------
   -- Size --
   ----------

   function Size
    (Self : in Q_Rect_F'Class)
       return Qt4.Size_Fs.Q_Size_F
   is
   begin
      return Returns : Qt4.Size_Fs.Q_Size_F do
         QRectF_size (Qt4.Size_Fs.Internals.QSizeF_View (Returns), Self.Object);
      end return;
   end Size;

   ---------------------
   -- To_Aligned_Rect --
   ---------------------

   function To_Aligned_Rect
    (Self : in Q_Rect_F'Class)
       return Qt4.Rects.Q_Rect
   is
   begin
      return Returns : Qt4.Rects.Q_Rect do
         QRectF_toAlignedRect (Qt4.Rects.Internals.QRect_View (Returns), Self.Object);
      end return;
   end To_Aligned_Rect;

   -------------
   -- To_Rect --
   -------------

   function To_Rect
    (Self : in Q_Rect_F'Class)
       return Qt4.Rects.Q_Rect
   is
   begin
      return Returns : Qt4.Rects.Q_Rect do
         QRectF_toRect (Qt4.Rects.Internals.QRect_View (Returns), Self.Object);
      end return;
   end To_Rect;

   ---------
   -- Top --
   ---------

   function Top
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real
   is
   begin
      return QRectF_top (Self.Object);
   end Top;

   --------------
   -- Top_Left --
   --------------

   function Top_Left
    (Self : in Q_Rect_F'Class)
       return Qt4.Point_Fs.Q_Point_F
   is
   begin
      return Returns : Qt4.Point_Fs.Q_Point_F do
         QRectF_topLeft (Qt4.Point_Fs.Internals.QPointF_View (Returns), Self.Object);
      end return;
   end Top_Left;

   ---------------
   -- Top_Right --
   ---------------

   function Top_Right
    (Self : in Q_Rect_F'Class)
       return Qt4.Point_Fs.Q_Point_F
   is
   begin
      return Returns : Qt4.Point_Fs.Q_Point_F do
         QRectF_topRight (Qt4.Point_Fs.Internals.QPointF_View (Returns), Self.Object);
      end return;
   end Top_Right;

   ---------------
   -- Translate --
   ---------------

   procedure Translate
    (Self : in out Q_Rect_F'Class;
     Dx : in Qt4.Q_Real;
     Dy : in Qt4.Q_Real)
   is
   begin
      QRectF_translate_qreal_qreal (Self.Object, Dx, Dy);
   end Translate;

   ---------------
   -- Translate --
   ---------------

   procedure Translate
    (Self : in out Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
   is
   begin
      QRectF_translate_QPointFCR (Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
   end Translate;

   ----------------
   -- Translated --
   ----------------

   function Translated
    (Self : in Q_Rect_F'Class;
     Dx : in Qt4.Q_Real;
     Dy : in Qt4.Q_Real)
       return Q_Rect_F
   is
   begin
      return Returns : Q_Rect_F do
         QRectF_translated_qreal_qreal (Returns.Object, Self.Object, Dx, Dy);
      end return;
   end Translated;

   ----------------
   -- Translated --
   ----------------

   function Translated
    (Self : in Q_Rect_F'Class;
     P : in Qt4.Point_Fs.Q_Point_F'Class)
       return Q_Rect_F
   is
   begin
      return Returns : Q_Rect_F do
         QRectF_translated_QPointFCR (Returns.Object, Self.Object, Qt4.Point_Fs.Internals.QPointF_View (P));
      end return;
   end Translated;

   ------------
   -- United --
   ------------

   function United
    (Self : in Q_Rect_F'Class;
     Other : in Q_Rect_F'Class)
       return Q_Rect_F
   is
   begin
      return Returns : Q_Rect_F do
         QRectF_united_QRectFCR (Returns.Object, Self.Object, Other.Object);
      end return;
   end United;

   -----------
   -- Width --
   -----------

   function Width
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real
   is
   begin
      return QRectF_width (Self.Object);
   end Width;

   -------
   -- X --
   -------

   function X
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real
   is
   begin
      return QRectF_x (Self.Object);
   end X;

   -------
   -- Y --
   -------

   function Y
    (Self : in Q_Rect_F'Class)
       return Qt4.Q_Real
   is
   begin
      return QRectF_y (Self.Object);
   end Y;

   ---------
   -- "=" --
   ---------

   function "="
    (R_1 : in Q_Rect_F;
     R_2 : in Q_Rect_F)
       return Boolean
   is
   begin
      return Interfaces.C."/=" (eq_QRectFCR_QRectFCR (R_1.Object, R_2.Object), 0);
   end "=";

   ---------------
   -- Internals --
   ---------------

   package body Internals is

   -----------------
   -- QRectF_View --
   -----------------

      function QRectF_View
       (Item : in Q_Rect_F'Class)
          return QRectF_Access
      is
      begin
         return Item.Object;
      end QRectF_View;

      package QRectF_Conversions is
        new System.Address_To_Access_Conversions
             (QRectF);

   ----------------------
   -- QRectFTo_Pointer --
   ----------------------

      function To_Pointer
       (Address : in System.Address)
          return QRectF_Access
      is
      begin
         return
           QRectF_Access
            (QRectF_Conversions.To_Pointer
            (Address));
      end To_Pointer;

   ----------------------
   -- QRectFTo_Address --
   ----------------------

      function To_Address
       (Pointer : in QRectF_Access)
          return System.Address
      is
      begin
         return
           QRectF_Conversions.To_Address
            (QRectF_Conversions.Object_Pointer
              (Pointer));
      end To_Address;

   --------------------
   -- Create_Wrapper --
   --------------------

      function Create_Wrapper
       (Item : in Internals.QRectF_Access)
          return Q_Rect_F
      is
      begin
         return Q_Rect_F'
          (Ada.Finalization.Controlled with
             Object  => Item,
             Wrapper => True,
             others  => <>);
      end Create_Wrapper;

   end Internals;

end Qt4.Rect_Fs;
